--- emacs20/wnn7egg-com.el.orig	2002-05-26 15:00:00 UTC
+++ emacs20/wnn7egg-com.el
@@ -73,6 +73,8 @@
 ;; Japanese
 
 (eval-and-compile
+  (if (string< mule-version "6.0") ;; Emacs 22 or lesser.
+      (progn
 (define-ccl-program ccl-decode-fixed-euc-jp
   `(2
     ((r2 = ,(charset-id 'japanese-jisx0208))
@@ -125,8 +127,24 @@
       (read r0)
       (repeat)))))
 )
+;; From Handa-san. [mule-ja : No.09414]
+(define-charset 'fixed-euc-jp
+  "Fixed EUC Japanese"
+  :dimension 2
+  :superset '(ascii
+	      (katakana-jisx0201 . #x80)
+	      (japanese-jisx0208 . #x8080)
+	      (japanese-jisx0212 . #x8000)))
 
-(if (not (coding-system-p 'fixed-euc-jp))
+(define-coding-system 'fixed-euc-jp
+  "Coding System for fixed EUC Japanese"
+  :mnemonic ?W
+  :coding-type 'charset
+  :charset-list '(fixed-euc-jp))
+))
+
+(if (and (string< mule-version "6.0") ;; Emacs 22 or lesser.
+	 (not (coding-system-p 'fixed-euc-jp)))
     (make-coding-system 'fixed-euc-jp 4 ?W 
 		"Coding System for fixed EUC Japanese"
 		(cons ccl-decode-fixed-euc-jp ccl-encode-fixed-euc-jp)))
@@ -152,8 +170,11 @@
       (write-read-repeat r0))))))
 
 (if (not (coding-system-p 'egg-binary))
-    (make-coding-system 'egg-binary 4 ?W "Coding System for binary data"
-		    (cons ccl-decode-egg-binary ccl-encode-egg-binary)))
+     (define-coding-system 'egg-binary "Coding System for binary data"
+      :mnemonic ?W :coding-type 'ccl :ccl-decoder ccl-decode-egg-binary
+      :ccl-encoder ccl-encode-egg-binary))
+;    (make-coding-system 'egg-binary 4 ?W "Coding System for binary data"
+;		    (cons ccl-decode-egg-binary ccl-encode-egg-binary)))
 
 
 (defun comm-format-u32c (uint32c)
@@ -295,10 +316,16 @@ V: Fixed length string (0x00 terminated).  This takes 
 (defun comm-unpack-u32 ()
   (progn
     (comm-require-process-output 4)
+    (if (= integer_width_29bit 1)
     (+ (lsh (comm-following+forward-char) 24)
        (lsh (comm-following+forward-char) 16)
        (lsh (comm-following+forward-char) 8)
-       (comm-following+forward-char))))
+          (comm-following+forward-char))
+      ;; for 62bit width
+      (ash (lsh (+ (lsh (comm-following+forward-char) 24)
+                  (lsh (comm-following+forward-char) 16)
+                  (lsh (comm-following+forward-char) 8)
+                  (comm-following+forward-char)) 30) -30))))
 
 (defun comm-unpack-u16 ()
   (progn
