--- emacs20/wnn7egg.el.orig	2002-05-26 15:00:00 UTC
+++ emacs20/wnn7egg.el
@@ -435,8 +435,9 @@
     (require 'overlay))
 
 (if (not (featurep 'xemacs))
-    (defun characterp (form)
+    (defun egg-characterp (form)
       (numberp form))
+  (defalias 'egg-characterp 'characterp)
   ;; 97.2.4 Created by J.Hein to simulate Mule-2.3
   (defun egg-read-event ()
     "FSFmacs event emulator that shoves non key events into
@@ -451,7 +452,7 @@ unread-command-events to facilitate translation from M
 	      (setq ch (or (event-to-character event) key))
 	    (if (eq 1 (event-modifier-bits event))
 		(setq ch
-		      (if (characterp key)
+		      (if (egg-characterp key)
 			  (or (int-to-char (- (char-to-int key) 96))
 			      (int-to-char (- (char-to-int key) 64)))
 			(event-to-character event)))
@@ -461,14 +462,14 @@ unread-command-events to facilitate translation from M
 
 (defun coerce-string (form)
   (cond((stringp form) form)
-       ((characterp form) (char-to-string form))))
+       ((egg-characterp form) (char-to-string form))))
 
 (defun coerce-internal-string (form)
   (cond((stringp form)
 	(if (= (length form) 1) 
 	    (string-to-char form)
 	  form))
-       ((characterp form) form)))
+       ((egg-characterp form) form)))
 
 ;;; kill-all-local-variables $B$+$iJ]8n$9$k(B local variables $B$r;XDj$G$-$k(B
 ;;; $B$h$&$KJQ99$9$k!#(B
@@ -707,10 +708,10 @@ unread-command-events to facilitate translation from M
 
 (defun menu:item-string (item)
   (cond ((stringp item) item)
-	((characterp item) (char-to-string item))
+	((egg-characterp item) (char-to-string item))
 	((consp item)
 	 (let ((str (cond ((stringp (car item)) (car item))
-			  ((characterp (car item)) (char-to-string (car item)))
+			  ((egg-characterp (car item)) (char-to-string (car item)))
 			  (t ""))))
 	   (if menu:*display-item-value*
 	       (format "%s [%s]" str (cdr item))
@@ -719,7 +720,7 @@ unread-command-events to facilitate translation from M
 
 (defun menu:item-value (item)
   (cond ((stringp item) item)
-	((characterp item) (char-to-string item))
+	((egg-characterp item) (char-to-string item))
 	((consp item) (cdr item))
 	(t "")))
 
@@ -1297,14 +1298,15 @@ its-defrule, its-defrule-conditional, defule-select-mo
 			(for-each* (cdr vars) body)
 			(list 'setq tvar (list 'cdr tvar))))))))
 			     
-(put 'dolist 'lisp-indent-hook 1)
+(eval-when-compile (require 'cl-lib)) ;; dolist
+;;;(put 'dolist 'lisp-indent-hook 1)
+;;;
+;;;(defmacro dolist (pair &rest body)
+;;;  "(dolist (VAR LISTFORM) . BODY) $B$O(BVAR $B$K=g<!(B LISTFORM $B$NMWAG$rB+G{$7(B
+;;;$B$F(B BODY $B$r<B9T$9$k(B"
+;;;
+;;;  (for-each* (list pair) (cons 'progn body)))
 
-(defmacro dolist (pair &rest body)
-  "(dolist (VAR LISTFORM) . BODY) $B$O(BVAR $B$K=g<!(B LISTFORM $B$NMWAG$rB+G{$7(B
-$B$F(B BODY $B$r<B9T$9$k(B"
-
-  (for-each* (list pair) (cons 'progn body)))
-
 ;;;
 ;;; defrule
 ;;; 
@@ -1332,7 +1334,7 @@ its-defrule, its-defrule-conditional, defule-select-mo
       (and (consp action)
 	   (or (stringp (car action))
 	       (and (consp (car action))
-		    (characterp (car (car action))))
+		    (egg-characterp (car (car action))))
 	       (null (car action)))
 	   (or (null (car (cdr action)))
 	       (stringp (car (cdr action)))))))
@@ -1667,15 +1669,15 @@ OUTPUTn)))$B$O(B INPUT $B$,F~NO$5$l$?;~$K>uBV(B ST
 	(insert ch))
       
       (defun its:ordinal-charp (ch)
-	(and (characterp ch) (<= ch 127)
+	(and (egg-characterp ch) (<= ch 127)
 	     (eq (lookup-key fence-mode-map (char-to-string ch)) 'fence-self-insert-command)))
       
       (defun its:delete-charp (ch)
-	(and (characterp ch) (<= ch 127)
+	(and (egg-characterp ch) (<= ch 127)
 	     (eq (lookup-key fence-mode-map (char-to-string ch)) 'fence-backward-delete-char)))
       
       (defun its:tabp (ch)
-	(and (characterp ch) (<= ch 127)
+	(and (egg-characterp ch) (<= ch 127)
 	     (eq (lookup-key fence-mode-map (char-to-string ch)) 'egg-predict-start-parttime)))
 
       (defvar egg:fence-buffer nil "Buffer fence is active in")
@@ -1700,12 +1702,28 @@ OUTPUTn)))$B$O(B INPUT $B$,F~NO$5$l$?;~$K>uBV(B ST
 	  nil)
       (following-char)))
   
+  (defun its:read-char-exclusive (&optional prompt inherit-input-method)
+    "`read-char-exclusive' that behaves like the ones in Emacs 22 or older."
+    (let (event char mask base)
+      (while (not char)
+	(setq event (read-event prompt inherit-input-method)
+	      char nil)
+	;; The code stolen from poe.el.
+	(cond ((symbolp event)
+	       ;; mask is (BASE-TYPE MODIFIER-BITS) or nil.
+	       (if (and (setq mask (get event 'event-symbol-element-mask))
+			(setq base (get (car mask) 'ascii-character)))
+		   (setq char (logior base (car (cdr mask))))))
+	      ((integerp event)
+	       (setq char event))))
+      char))
+
   (defun its:read-char ()
     (if (= (point) its:*buff-e*)
 	(progn 
 	  (setq its:*char-from-buff* nil)
 	  (if its:*interactive*
-	      (read-char-exclusive)
+	      (its:read-char-exclusive)
 	    nil))
       (let ((ch (following-char)))
 	(setq its:*char-from-buff* t)
@@ -1879,7 +1897,7 @@ Arguments are STRING, ALIST and optional PRED. ALIST m
 	      (cons (list string 
 			  (let ((action-output (action-output action)))
 			    (cond((and (consp action-output)
-				       (characterp (car action-output)))
+				       (egg-characterp (car action-output)))
 				  (format "%s..."
 				  (nth (car action-output) (cdr action-output))))
 				 ((stringp action-output)
@@ -1967,7 +1985,7 @@ Arguments are STRING, ALIST and optional PRED. ALIST m
       (setq action (get-action newmap))
 
       (cond
-       ((and its:*interactive* (not its:*char-from-buff*) (characterp ch) (= ch ?\^@))
+       ((and its:*interactive* (not its:*char-from-buff*) (egg-characterp ch) (= ch ?\^@))
 	(delete-region its:*buff-s* (point))
 	(let ((i 1))
 	  (while (<= i its:*level*)
@@ -2445,6 +2463,18 @@ Arguments are STRING, ALIST and optional PRED. ALIST m
 			   'egg-self-insert-command
 			   global-map)
 
+(if (let ((keymap (make-sparse-keymap)))
+      (suppress-keymap keymap)
+      (lookup-key keymap [remap]))
+    ;; Emacs 22 and greater.
+    (defadvice suppress-keymap (after remap-egg-self-insert-command activate)
+      "Remap `egg-self-insert-command' to `undefined'."
+      (define-key (ad-get-arg 0) [remap egg-self-insert-command] 'undefined))
+  (defadvice suppress-keymap (after remap-egg-self-insert-command activate)
+    "Remap `egg-self-insert-command' to `undefined'."
+    (substitute-key-definition 'egg-self-insert-command 'undefined
+			       (ad-get-arg 0) global-map)))
+
 ;; $BF~NOM=B,D>A0EPO?:o=|MQ$NBP1~(B
 (substitute-key-definition 'delete-backward-char 
 			   'egg-delete-backward-char
@@ -2622,7 +2652,7 @@ two arguments START and END correspoding to character 
 	  (egg:enter-fence-mode-and-self-insert))
       (progn
 	(if (and (eq last-command 'egg-self-insert-command)
-		 (> last-command-char ? ))
+		 (> last-command-event ? ))
 	    (egg:cancel-undo-boundary))
 	(self-insert-command arg)
 	(if egg-insert-after-hook
@@ -2880,6 +2910,14 @@ FACE $B$O(B nil $B$G$J$1$l$P!"%U%'%s%96h4V$NI=<($K$
       (egg-predict-clear))
     (resume-undo-list)
     (insert kakutei-string)
+
+  ;; Workaround to remove position to which `undo' goes.
+  (if (car buffer-undo-list)
+      (if (numberp (cadr buffer-undo-list))
+	  (setcdr buffer-undo-list (nthcdr 2 buffer-undo-list)))
+    (if (numberp (nth 2 buffer-undo-list))
+	(setcdr (cdr buffer-undo-list) (nthcdr 3 buffer-undo-list))))
+
     (when (wnn7-p)
       (if (> (length kakutei-string) 0)
 	  (progn
